diff --git a/third_party/rust/ucd-util/LICENSE-APACHE b/third_party/rust/ucd-util/LICENSE-APACHE
new file mode 100644
index 000000000000..16fe87b06e80
--- /dev/null
+++ b/third_party/rust/ucd-util/LICENSE-APACHE
@@ -0,0 +1,201 @@
+                              Apache License
+                        Version 2.0, January 2004
+                     http://www.apache.org/licenses/
+
+TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+1. Definitions.
+
+   "License" shall mean the terms and conditions for use, reproduction,
+   and distribution as defined by Sections 1 through 9 of this document.
+
+   "Licensor" shall mean the copyright owner or entity authorized by
+   the copyright owner that is granting the License.
+
+   "Legal Entity" shall mean the union of the acting entity and all
+   other entities that control, are controlled by, or are under common
+   control with that entity. For the purposes of this definition,
+   "control" means (i) the power, direct or indirect, to cause the
+   direction or management of such entity, whether by contract or
+   otherwise, or (ii) ownership of fifty percent (50%) or more of the
+   outstanding shares, or (iii) beneficial ownership of such entity.
+
+   "You" (or "Your") shall mean an individual or Legal Entity
+   exercising permissions granted by this License.
+
+   "Source" form shall mean the preferred form for making modifications,
+   including but not limited to software source code, documentation
+   source, and configuration files.
+
+   "Object" form shall mean any form resulting from mechanical
+   transformation or translation of a Source form, including but
+   not limited to compiled object code, generated documentation,
+   and conversions to other media types.
+
+   "Work" shall mean the work of authorship, whether in Source or
+   Object form, made available under the License, as indicated by a
+   copyright notice that is included in or attached to the work
+   (an example is provided in the Appendix below).
+
+   "Derivative Works" shall mean any work, whether in Source or Object
+   form, that is based on (or derived from) the Work and for which the
+   editorial revisions, annotations, elaborations, or other modifications
+   represent, as a whole, an original work of authorship. For the purposes
+   of this License, Derivative Works shall not include works that remain
+   separable from, or merely link (or bind by name) to the interfaces of,
+   the Work and Derivative Works thereof.
+
+   "Contribution" shall mean any work of authorship, including
+   the original version of the Work and any modifications or additions
+   to that Work or Derivative Works thereof, that is intentionally
+   submitted to Licensor for inclusion in the Work by the copyright owner
+   or by an individual or Legal Entity authorized to submit on behalf of
+   the copyright owner. For the purposes of this definition, "submitted"
+   means any form of electronic, verbal, or written communication sent
+   to the Licensor or its representatives, including but not limited to
+   communication on electronic mailing lists, source code control systems,
+   and issue tracking systems that are managed by, or on behalf of, the
+   Licensor for the purpose of discussing and improving the Work, but
+   excluding communication that is conspicuously marked or otherwise
+   designated in writing by the copyright owner as "Not a Contribution."
+
+   "Contributor" shall mean Licensor and any individual or Legal Entity
+   on behalf of whom a Contribution has been received by Licensor and
+   subsequently incorporated within the Work.
+
+2. Grant of Copyright License. Subject to the terms and conditions of
+   this License, each Contributor hereby grants to You a perpetual,
+   worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+   copyright license to reproduce, prepare Derivative Works of,
+   publicly display, publicly perform, sublicense, and distribute the
+   Work and such Derivative Works in Source or Object form.
+
+3. Grant of Patent License. Subject to the terms and conditions of
+   this License, each Contributor hereby grants to You a perpetual,
+   worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+   (except as stated in this section) patent license to make, have made,
+   use, offer to sell, sell, import, and otherwise transfer the Work,
+   where such license applies only to those patent claims licensable
+   by such Contributor that are necessarily infringed by their
+   Contribution(s) alone or by combination of their Contribution(s)
+   with the Work to which such Contribution(s) was submitted. If You
+   institute patent litigation against any entity (including a
+   cross-claim or counterclaim in a lawsuit) alleging that the Work
+   or a Contribution incorporated within the Work constitutes direct
+   or contributory patent infringement, then any patent licenses
+   granted to You under this License for that Work shall terminate
+   as of the date such litigation is filed.
+
+4. Redistribution. You may reproduce and distribute copies of the
+   Work or Derivative Works thereof in any medium, with or without
+   modifications, and in Source or Object form, provided that You
+   meet the following conditions:
+
+   (a) You must give any other recipients of the Work or
+       Derivative Works a copy of this License; and
+
+   (b) You must cause any modified files to carry prominent notices
+       stating that You changed the files; and
+
+   (c) You must retain, in the Source form of any Derivative Works
+       that You distribute, all copyright, patent, trademark, and
+       attribution notices from the Source form of the Work,
+       excluding those notices that do not pertain to any part of
+       the Derivative Works; and
+
+   (d) If the Work includes a "NOTICE" text file as part of its
+       distribution, then any Derivative Works that You distribute must
+       include a readable copy of the attribution notices contained
+       within such NOTICE file, excluding those notices that do not
+       pertain to any part of the Derivative Works, in at least one
+       of the following places: within a NOTICE text file distributed
+       as part of the Derivative Works; within the Source form or
+       documentation, if provided along with the Derivative Works; or,
+       within a display generated by the Derivative Works, if and
+       wherever such third-party notices normally appear. The contents
+       of the NOTICE file are for informational purposes only and
+       do not modify the License. You may add Your own attribution
+       notices within Derivative Works that You distribute, alongside
+       or as an addendum to the NOTICE text from the Work, provided
+       that such additional attribution notices cannot be construed
+       as modifying the License.
+
+   You may add Your own copyright statement to Your modifications and
+   may provide additional or different license terms and conditions
+   for use, reproduction, or distribution of Your modifications, or
+   for any such Derivative Works as a whole, provided Your use,
+   reproduction, and distribution of the Work otherwise complies with
+   the conditions stated in this License.
+
+5. Submission of Contributions. Unless You explicitly state otherwise,
+   any Contribution intentionally submitted for inclusion in the Work
+   by You to the Licensor shall be under the terms and conditions of
+   this License, without any additional terms or conditions.
+   Notwithstanding the above, nothing herein shall supersede or modify
+   the terms of any separate license agreement you may have executed
+   with Licensor regarding such Contributions.
+
+6. Trademarks. This License does not grant permission to use the trade
+   names, trademarks, service marks, or product names of the Licensor,
+   except as required for reasonable and customary use in describing the
+   origin of the Work and reproducing the content of the NOTICE file.
+
+7. Disclaimer of Warranty. Unless required by applicable law or
+   agreed to in writing, Licensor provides the Work (and each
+   Contributor provides its Contributions) on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+   implied, including, without limitation, any warranties or conditions
+   of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+   PARTICULAR PURPOSE. You are solely responsible for determining the
+   appropriateness of using or redistributing the Work and assume any
+   risks associated with Your exercise of permissions under this License.
+
+8. Limitation of Liability. In no event and under no legal theory,
+   whether in tort (including negligence), contract, or otherwise,
+   unless required by applicable law (such as deliberate and grossly
+   negligent acts) or agreed to in writing, shall any Contributor be
+   liable to You for damages, including any direct, indirect, special,
+   incidental, or consequential damages of any character arising as a
+   result of this License or out of the use or inability to use the
+   Work (including but not limited to damages for loss of goodwill,
+   work stoppage, computer failure or malfunction, or any and all
+   other commercial damages or losses), even if such Contributor
+   has been advised of the possibility of such damages.
+
+9. Accepting Warranty or Additional Liability. While redistributing
+   the Work or Derivative Works thereof, You may choose to offer,
+   and charge a fee for, acceptance of support, warranty, indemnity,
+   or other liability obligations and/or rights consistent with this
+   License. However, in accepting such obligations, You may act only
+   on Your own behalf and on Your sole responsibility, not on behalf
+   of any other Contributor, and only if You agree to indemnify,
+   defend, and hold each Contributor harmless for any liability
+   incurred by, or claims asserted against, such Contributor by reason
+   of your accepting any such warranty or additional liability.
+
+END OF TERMS AND CONDITIONS
+
+APPENDIX: How to apply the Apache License to your work.
+
+   To apply the Apache License to your work, attach the following
+   boilerplate notice, with the fields enclosed by brackets "[]"
+   replaced with your own identifying information. (Don't include
+   the brackets!)  The text should be enclosed in the appropriate
+   comment syntax for the file format. We also recommend that a
+   file or class name and description of purpose be included on the
+   same "printed page" as the copyright notice for easier
+   identification within third-party archives.
+
+Copyright [yyyy] [name of copyright owner]
+
+Licensed under the Apache License, Version 2.0 (the "License");
+you may not use this file except in compliance with the License.
+You may obtain a copy of the License at
+
+	http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS,
+WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+See the License for the specific language governing permissions and
+limitations under the License.
diff --git a/third_party/rust/ucd-util/LICENSE-MIT b/third_party/rust/ucd-util/LICENSE-MIT
new file mode 100644
index 000000000000..3b0a5dc09c1e
--- /dev/null
+++ b/third_party/rust/ucd-util/LICENSE-MIT
@@ -0,0 +1,21 @@
+The MIT License (MIT)
+
+Copyright (c) 2015 Andrew Gallant
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
diff --git a/third_party/rust/ucd-util/src/hangul.rs b/third_party/rust/ucd-util/src/hangul.rs
new file mode 100644
index 000000000000..dd3bbc8f5019
--- /dev/null
+++ b/third_party/rust/ucd-util/src/hangul.rs
@@ -0,0 +1,105 @@
+use unicode_tables::jamo_short_name::JAMO_SHORT_NAME;
+
+// This implementation should correspond to the algorithms described in
+// Unicode 3.12.
+
+/// A set of ranges that corresponds to the set of all Hangul syllable
+/// codepoints.
+///
+/// These ranges are defined in Unicode 4.8 Table 4-13.
+pub const RANGE_HANGUL_SYLLABLE: &'static [(u32, u32)] = &[
+    (0xAC00, 0xD7A3),
+];
+
+const S_BASE: u32 = 0xAC00;
+const L_BASE: u32 = 0x1100;
+const V_BASE: u32 = 0x1161;
+const T_BASE: u32 = 0x11A7;
+const T_COUNT: u32 = 28;
+const N_COUNT: u32 = 588;
+
+/// Return the character name of the given precomposed Hangul codepoint.
+///
+/// If the given codepoint does not correspond to a precomposed Hangul
+/// codepoint in the inclusive range `AC00..D7A3`, then this returns `None`.
+///
+/// This implements the algorithms described in Unicode 3.12 and Unicode 4.8.
+pub fn hangul_name(cp: u32) -> Option<String> {
+    let mut name = "HANGUL SYLLABLE ".to_string();
+    let (lpart, vpart, tpart) = match hangul_full_canonical_decomposition(cp) {
+        None => return None,
+        Some(triple) => triple,
+    };
+
+    name.push_str(jamo_short_name(lpart));
+    name.push_str(jamo_short_name(vpart));
+    name.push_str(tpart.map_or("", jamo_short_name));
+    Some(name)
+}
+
+/// Return the full canonical decomposition of the given precomposed Hangul
+/// codepoint.
+///
+/// If the decomposition does not have any trailing consonant, then the third
+/// part of the tuple returned is `None`.
+///
+/// If the given codepoint does not correspond to a precomposed Hangul
+/// codepoint in the inclusive range `AC00..D7A3`, then this returns `None`.
+///
+/// This implements the algorithms described in Unicode 3.12 and Unicode 4.8.
+pub fn hangul_full_canonical_decomposition(
+    cp: u32,
+) -> Option<(u32, u32, Option<u32>)> {
+    if !(0xAC00 <= cp && cp <= 0xD7A3) {
+        return None;
+    }
+
+    let s_index = cp - S_BASE;
+    let l_index = s_index / N_COUNT;
+    let v_index = (s_index % N_COUNT) / T_COUNT;
+    let t_index = s_index % T_COUNT;
+
+    let l_part = L_BASE + l_index;
+    let v_part = V_BASE + v_index;
+    let t_part =
+        if t_index == 0 {
+            None
+        } else {
+            Some(T_BASE + t_index)
+        };
+    Some((l_part, v_part, t_part))
+}
+
+fn jamo_short_name(cp: u32) -> &'static str {
+    let i = JAMO_SHORT_NAME.binary_search_by_key(&cp, |p| p.0).unwrap();
+    JAMO_SHORT_NAME[i].1
+}
+
+#[cfg(test)]
+mod tests {
+    use super::{hangul_name, hangul_full_canonical_decomposition};
+
+    #[test]
+    fn canon_decomp() {
+        assert_eq!(
+            hangul_full_canonical_decomposition(0xD4DB),
+            Some((0x1111, 0x1171, Some(0x11B6))));
+    }
+
+    #[test]
+    fn name() {
+        assert_eq!(hangul_name(0xD4DB).unwrap(), "HANGUL SYLLABLE PWILH");
+    }
+
+    #[test]
+    fn all() {
+        for cp in 0xAC00..(0xD7A3 + 1) {
+            hangul_name(cp).unwrap();
+        }
+    }
+
+    #[test]
+    fn invalid() {
+        assert!(hangul_name(0).is_none());
+    }
+}
diff --git a/third_party/rust/ucd-util/src/ideograph.rs b/third_party/rust/ucd-util/src/ideograph.rs
new file mode 100644
index 000000000000..0502c6ecf2c3
--- /dev/null
+++ b/third_party/rust/ucd-util/src/ideograph.rs
@@ -0,0 +1,83 @@
+/// A set of ranges that corresponds to the set of all ideograph codepoints.
+///
+/// These ranges are defined in Unicode 4.8 Table 4-13.
+pub const RANGE_IDEOGRAPH: &'static [(u32, u32)] = &[
+    (0x3400, 0x4DB5),
+    (0x4E00, 0x9FD5),
+    (0x4E00, 0x9FD5),
+    (0x20000, 0x2A6D6),
+    (0x2A700, 0x2B734),
+    (0x2B740, 0x2B81D),
+    (0x2B820, 0x2CEA1),
+    (0x17000, 0x187EC),
+    (0xF900, 0xFA6D),
+    (0xFA70, 0xFAD9),
+    (0x2F800, 0x2FA1D),
+];
+
+/// Return the character name of the given ideograph codepoint.
+///
+/// This operation is only defined on ideographic codepoints. This includes
+/// precisely the following inclusive ranges:
+///
+/// * `3400..4DB5`
+/// * `4E00..9FD5`
+/// * `20000..2A6D6`
+/// * `2A700..2B734`
+/// * `2B740..2B81D`
+/// * `2B820..2CEA1`
+/// * `17000..187EC`
+/// * `F900..FA6D`
+/// * `FA70..FAD9`
+/// * `2F800..2FA1D`
+///
+/// If the given codepoint is not in any of the above ranges, then `None` is
+/// returned.
+///
+/// This implements the algorithm described in Unicode 4.8.
+pub fn ideograph_name(cp: u32) -> Option<String> {
+    // This match should be in sync with the `RANGE_IDEOGRAPH` constant.
+    match cp {
+        0x3400...0x4DB5
+        | 0x4E00...0x9FD5
+        | 0x20000...0x2A6D6
+        | 0x2A700...0x2B734
+        | 0x2B740...0x2B81D
+        | 0x2B820...0x2CEA1 => {
+            Some(format!("CJK UNIFIED IDEOGRAPH-{:04X}", cp))
+        }
+        0x17000...0x187EC => {
+            Some(format!("TANGUT IDEOGRAPH-{:04X}", cp))
+        }
+        0xF900...0xFA6D | 0xFA70...0xFAD9 | 0x2F800...0x2FA1D => {
+            Some(format!("CJK COMPATIBILITY IDEOGRAPH-{:04X}", cp))
+        }
+        _ => None,
+    }
+}
+
+#[cfg(test)]
+mod tests {
+    use super::ideograph_name;
+
+    #[test]
+    fn name() {
+        assert_eq!(
+            ideograph_name(0x4E00).unwrap(),
+            "CJK UNIFIED IDEOGRAPH-4E00");
+        assert_eq!(
+            ideograph_name(0x9FD5).unwrap(),
+            "CJK UNIFIED IDEOGRAPH-9FD5");
+        assert_eq!(
+            ideograph_name(0x17000).unwrap(),
+            "TANGUT IDEOGRAPH-17000");
+        assert_eq!(
+            ideograph_name(0xF900).unwrap(),
+            "CJK COMPATIBILITY IDEOGRAPH-F900");
+    }
+
+    #[test]
+    fn invalid() {
+        assert!(ideograph_name(0).is_none());
+    }
+}
diff --git a/third_party/rust/ucd-util/src/lib.rs b/third_party/rust/ucd-util/src/lib.rs
new file mode 100644
index 000000000000..4dc56063753e
--- /dev/null
+++ b/third_party/rust/ucd-util/src/lib.rs
@@ -0,0 +1,28 @@
+/*!
+The `ucd-util` crate contains a smattering of utility functions that implement
+various algorithms specified by Unicode. There is no specific goal for
+exhaustiveness. Instead, implementations should be added on an as-needed basis.
+
+A *current* design constraint of this crate is that it should not bring in any
+large Unicode tables. For example, to use the various property name and value
+canonicalization functions, you'll need to supply your own table, which can
+be generated using `ucd-generate`.
+*/
+
+#![deny(missing_docs)]
+
+mod hangul;
+mod ideograph;
+mod name;
+mod property;
+mod unicode_tables;
+
+pub use hangul::{
+    RANGE_HANGUL_SYLLABLE, hangul_name, hangul_full_canonical_decomposition,
+};
+pub use ideograph::{RANGE_IDEOGRAPH, ideograph_name};
+pub use name::{character_name_normalize, symbolic_name_normalize};
+pub use property::{
+    PropertyTable, PropertyValueTable, PropertyValues,
+    canonical_property_name, property_values, canonical_property_value,
+};
diff --git a/third_party/rust/ucd-util/src/name.rs b/third_party/rust/ucd-util/src/name.rs
new file mode 100644
index 000000000000..634d2eddfe75
--- /dev/null
+++ b/third_party/rust/ucd-util/src/name.rs
@@ -0,0 +1,180 @@
+/// Normalize the given character name in place according to UAX44-LM2.
+///
+/// See: http://unicode.org/reports/tr44/#UAX44-LM2
+pub fn character_name_normalize(string: &mut String) {
+    let bytes = unsafe {
+        // SAFETY: `character_name_normalize_bytes` guarantees that
+        // `bytes[..len]` is valid UTF-8.
+        string.as_mut_vec()
+    };
+    let len = character_name_normalize_bytes(bytes).len();
+    bytes.truncate(len);
+}
+
+/// Normalize the given character name in place according to UAX44-LM2.
+///
+/// The slice returned is guaranteed to be valid UTF-8 for all possible values
+/// of `slice`.
+///
+/// See: http://unicode.org/reports/tr44/#UAX44-LM2
+fn character_name_normalize_bytes(slice: &mut [u8]) -> &mut [u8] {
+    // According to Unicode 4.8, character names consist only of Latin
+    // capital letters A to Z, ASCII digits, ASCII space or ASCII hypen.
+    // Therefore, we can do very simplistic case folding and operate on the
+    // raw bytes, since everything is ASCII. Note that we don't actually know
+    // whether `slice` is all ASCII or not, so we drop all non-ASCII bytes.
+    let mut next_write = 0;
+    let mut prev_space = true;
+    for i in 0..slice.len() {
+        // SAFETY ARGUMENT: To guarantee that the resulting slice is valid
+        // UTF-8, we ensure that the slice contains only ASCII bytes. In
+        // particular, we drop every non-ASCII byte from the normalized string.
+        let b = slice[i];
+        if b == b' ' {
+            prev_space = true;
+            continue;
+        } else if b == b'_' {
+            // Drop the underscore.
+        } else if b == b'-' {
+            let mut keep_hyphen = prev_space || slice.get(i+1) == Some(&b' ');
+            // We want to keep the hypen only if it isn't medial, which means
+            // it has at least one adjacent space character. However, there
+            // is one exception. We need to keep the hypen in the character
+            // (U+1180) named `HANGUL JUNGSEONG O-E`. So we check for that
+            // here.
+            let rest_e = slice[i+1..] == b"E"[..] || slice[i+1..] == b"e"[..];
+            if !keep_hyphen && rest_e {
+                keep_hyphen = slice[..next_write] == b"hanguljungseongo"[..];
+            }
+            if keep_hyphen {
+                slice[next_write] = b;
+                next_write += 1;
+            }
+        } else if b'A' <= b && b <= b'Z' {
+            slice[next_write] = b + (b'a' - b'A');
+            next_write += 1;
+        } else if b <= 0x7F {
+            slice[next_write] = b;
+            next_write += 1;
+        }
+        prev_space = false;
+    }
+    &mut slice[..next_write]
+}
+
+/// Normalize the given symbolic name in place according to UAX44-LM3.
+///
+/// A "symbolic name" typically corresponds to property names and property
+/// value aliases. Note, though, that it should not be applied to property
+/// string values.
+///
+/// See: http://unicode.org/reports/tr44/#UAX44-LM2
+pub fn symbolic_name_normalize(string: &mut String) {
+    let bytes = unsafe {
+        // SAFETY: `symbolic_name_normalize_bytes` guarantees that
+        // `bytes[..len]` is valid UTF-8.
+        string.as_mut_vec()
+    };
+    let len = symbolic_name_normalize_bytes(bytes).len();
+    bytes.truncate(len);
+}
+
+/// Normalize the given symbolic name in place according to UAX44-LM3.
+///
+/// A "symbolic name" typically corresponds to property names and property
+/// value aliases. Note, though, that it should not be applied to property
+/// string values.
+///
+/// The slice returned is guaranteed to be valid UTF-8 for all possible values
+/// of `slice`.
+///
+/// See: http://unicode.org/reports/tr44/#UAX44-LM3
+fn symbolic_name_normalize_bytes(slice: &mut [u8]) -> &mut [u8] {
+    // I couldn't find a place in the standard that specified that property
+    // names/aliases had a particular structure (unlike character names), but
+    // we assume that it's ASCII only and drop anything that isn't ASCII.
+    let mut start = 0;
+    if slice.len() >= 2 {
+        // Ignore any "is" prefix.
+        let starts_with_is =
+            slice[0..2] == b"is"[..]
+            || slice[0..2] == b"IS"[..]
+            || slice[0..2] == b"iS"[..]
+            || slice[0..2] == b"Is"[..];
+        if starts_with_is {
+            start = 2;
+        }
+    }
+    let mut next_write = 0;
+    for i in start..slice.len() {
+        // SAFETY ARGUMENT: To guarantee that the resulting slice is valid
+        // UTF-8, we ensure that the slice contains only ASCII bytes. In
+        // particular, we drop every non-ASCII byte from the normalized string.
+        let b = slice[i];
+        if b == b' ' || b == b'_' || b == b'-' {
+            continue;
+        } else if b'A' <= b && b <= b'Z' {
+            slice[next_write] = b + (b'a' - b'A');
+            next_write += 1;
+        } else if b <= 0x7F {
+            slice[next_write] = b;
+            next_write += 1;
+        }
+    }
+    &mut slice[..next_write]
+}
+
+#[cfg(test)]
+mod tests {
+    use super::{
+        character_name_normalize, character_name_normalize_bytes,
+        symbolic_name_normalize, symbolic_name_normalize_bytes,
+    };
+
+    fn char_norm(s: &str) -> String {
+        let mut s = s.to_string();
+        character_name_normalize(&mut s);
+        s
+    }
+
+    fn sym_norm(s: &str) -> String {
+        let mut s = s.to_string();
+        symbolic_name_normalize(&mut s);
+        s
+    }
+
+    #[test]
+    fn char_normalize() {
+        assert_eq!(char_norm("HANGUL JUNGSEONG O-E"), "hanguljungseongo-e");
+        assert_eq!(char_norm("zero-width space"), "zerowidthspace");
+        assert_eq!(char_norm("zerowidthspace"), "zerowidthspace");
+        assert_eq!(char_norm("ZERO WIDTH SPACE"), "zerowidthspace");
+        assert_eq!(char_norm("TIBETAN MARK TSA -PHRU"), "tibetanmarktsa-phru");
+    }
+
+    #[test]
+    fn sym_normalize() {
+        assert_eq!(sym_norm("Line_Break"), "linebreak");
+        assert_eq!(sym_norm("Line-break"), "linebreak");
+        assert_eq!(sym_norm("linebreak"), "linebreak");
+        assert_eq!(sym_norm("BA"), "ba");
+        assert_eq!(sym_norm("ba"), "ba");
+        assert_eq!(sym_norm("Greek"), "greek");
+        assert_eq!(sym_norm("isGreek"), "greek");
+        assert_eq!(sym_norm("IS_Greek"), "greek");
+    }
+
+    #[test]
+    fn valid_utf8_character() {
+        let mut x = b"abc\xFFxyz".to_vec();
+        let y = character_name_normalize_bytes(&mut x);
+        assert_eq!(y, b"abcxyz");
+    }
+
+    #[test]
+    fn valid_utf8_symbolic() {
+        let mut x = b"abc\xFFxyz".to_vec();
+        let y = symbolic_name_normalize_bytes(&mut x);
+        assert_eq!(y, b"abcxyz");
+    }
+}
diff --git a/third_party/rust/ucd-util/src/property.rs b/third_party/rust/ucd-util/src/property.rs
new file mode 100644
index 000000000000..7bbe56e96624
--- /dev/null
+++ b/third_party/rust/ucd-util/src/property.rs
@@ -0,0 +1,124 @@
+/// The type of a property name table.
+///
+/// A property name table is a sequence of sorted tuples, where the first
+/// value in each tuple is a normalized property name and the second value of
+/// each tuple is the corresponding canonical property name.
+pub type PropertyTable = &'static [(&'static str, &'static str)];
+
+/// Find the canonical property name for the given normalized property name.
+///
+/// If no such property exists, then `None` is returned.
+///
+/// The normalized property name must have been normalized according to
+/// UAX44 LM3, which can be done using `symbolic_name_normalize`.
+pub fn canonical_property_name(
+    property_table: PropertyTable,
+    normalized_property_name: &str,
+) -> Option<&'static str> {
+    property_table
+        .binary_search_by_key(&normalized_property_name, |&(n, _)| n)
+        .ok()
+        .map(|i| property_table[i].1)
+}
+
+/// Type of a property value table.
+///
+/// A property value table maps property names to a mapping of property values,
+/// where the mapping of property values is represented by a sequence of
+/// tuples. The first element of each tuple is a normalized property value
+/// while the second element of each tuple is the corresponding canonical
+/// property value.
+///
+/// Note that a property value table only includes values for properties that
+/// are catalogs, enumerations or binary properties. Properties that have
+/// string values (such as case or decomposition mappings), numeric values
+/// or are miscellaneous are not represented in this table.
+pub type PropertyValueTable = &'static [(&'static str, PropertyValues)];
+
+/// A mapping of property values for a specific property.
+///
+/// The first element of each tuple is a normalized property value while the
+/// second element of each tuple is the corresponding canonical property
+/// value.
+pub type PropertyValues = &'static [(&'static str, &'static str)];
+
+/// Find the set of possible property values for a given property.
+///
+/// The set returned is a mapping expressed as a sorted list of tuples.
+/// The first element of each tuple is a normalized property value while the
+/// second element of each tuple is the corresponding canonical property
+/// value.
+///
+/// If no such property exists, then `None` is returned.
+///
+/// The given property name must be in its canonical form, which can be
+/// found using `canonical_property_name`.
+pub fn property_values(
+    property_value_table: PropertyValueTable,
+    canonical_property_name: &str,
+) -> Option<PropertyValues> {
+    property_value_table
+        .binary_search_by_key(&canonical_property_name, |&(n, _)| n)
+        .ok()
+        .map(|i| property_value_table[i].1)
+}
+
+/// Find the canonical property value for the given normalized property
+/// value.
+///
+/// The given property values should correspond to the values for the property
+/// under question, which can be found using `property_values`.
+///
+/// If no such property value exists, then `None` is returned.
+///
+/// The normalized property value must have been normalized according to
+/// UAX44 LM3, which can be done using `symbolic_name_normalize`.
+pub fn canonical_property_value(
+    property_values: PropertyValues,
+    normalized_property_value: &str,
+) -> Option<&'static str> {
+    // This is cute. The types line up, so why not?
+    canonical_property_name(property_values, normalized_property_value)
+}
+
+
+#[cfg(test)]
+mod tests {
+    use unicode_tables::property_names::PROPERTY_NAMES;
+    use unicode_tables::property_values::PROPERTY_VALUES;
+
+    use super::{
+        canonical_property_name, property_values, canonical_property_value,
+    };
+
+    #[test]
+    fn canonical_property_name_1() {
+        assert_eq!(
+            canonical_property_name(PROPERTY_NAMES, "gc"),
+            Some("General_Category"));
+        assert_eq!(
+            canonical_property_name(PROPERTY_NAMES, "generalcategory"),
+            Some("General_Category"));
+        assert_eq!(
+            canonical_property_name(PROPERTY_NAMES, "g c"),
+            None);
+    }
+
+    #[test]
+    fn property_values_1() {
+        assert_eq!(
+            property_values(PROPERTY_VALUES, "White_Space"),
+            Some(&[
+                ("f", "No"), ("false", "No"), ("n", "No"), ("no", "No"),
+                ("t", "Yes"), ("true", "Yes"), ("y", "Yes"), ("yes", "Yes"),
+            ][..]));
+    }
+
+    #[test]
+    fn canonical_property_value_1() {
+        let values = property_values(PROPERTY_VALUES, "White_Space").unwrap();
+        assert_eq!(canonical_property_value(values, "false"), Some("No"));
+        assert_eq!(canonical_property_value(values, "t"), Some("Yes"));
+        assert_eq!(canonical_property_value(values, "F"), None);
+    }
+}
